# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import sys
import os
import shutil
import signal
import subprocess
from tempfile import mkstemp
import logging
import zipfile
from Crypto.Cipher import AES
import hashlib

encrypt=False

def encode_now(data,enc):
	ret=data
	if encrypt==True:
		iv_text= "ksdnfgalsfnk;sitaslghslahsklajadadqwewioq"
		iv = hashlib.md5()
		iv.update(iv_text)

		key_text = "fgaggfasgijasfojaf90249jasfd8a8d8aaSAsd"
		key = hashlib.md5()
		key.update(key_text)
		iv_result = iv.digest()
		key_result = key.digest()

		#print key.hexdigest()
		#print iv.hexdigest()

		mode = AES.MODE_CBC
		encryptor = AES.new(key_result, mode, IV=iv_result)

		if enc==True:
			length = 16 - (len(data) % 16)
			data += " "*length
			ret = encryptor.encrypt(data)
		else:
			decryptor = AES.new(key_result, mode, IV=iv_result)
			ret = decryptor.decrypt(data)
	return ret

def inp_set_encode():
	global encrypt
	encrypt=True

def inp_unset_encode():
	global encrypt
	encrypt=False
